/* global Services, APP_STARTUP, APP_SHUTDOWN */
/* exported startup, shutdown, install, uninstall */

"use strict";

var
	bgProcess,
	app_name = "Viewhance",
	app_baseURI = "chrome://" + app_name.toLowerCase() + "/content/";

Components.utils["import"]("resource://gre/modules/Services.jsm");
// Components.utils["import"]("resource://gre/modules/devtools/Console.jsm");

function startup(data, reason) {
	bgProcess = function(ev) {
		if (ev) {
			this.removeEventListener("load", bgProcess);
		}

		Components.classes["@mozilla.org/globalmessagemanager;1"]
							.getService(Components.interfaces.nsIMessageListenerManager)
							.loadFrameScript(app_baseURI + "frameScript.js", true);

		bgProcess = Services.appShell.hiddenDOMWindow.document;
		bgProcess = bgProcess.documentElement.appendChild(
			bgProcess.createElementNS("http://www.w3.org/1999/xhtml", "iframe")
		);
		bgProcess.setAttribute("id", app_name + "_bgProcess");
		bgProcess.setAttribute("src", app_baseURI + "background.html");
	};

	if (reason === APP_STARTUP) {
		Services.ww.registerNotification({
			observe: function(subject) {
				Services.ww.unregisterNotification(this);
				subject.addEventListener("load", bgProcess);
			}
		});
	}
	else {
		bgProcess();
	}
}

function shutdown(data, reason) {
	if (reason === APP_SHUTDOWN) {
		return;
	}

	Components.classes["@mozilla.org/globalmessagemanager;1"]
						.getService(Components.interfaces.nsIMessageListenerManager)
						.removeDelayedFrameScript(app_baseURI + "frameScript.js");

	if (bgProcess) {
		bgProcess.parentNode.removeChild(bgProcess);
		bgProcess = null;
	}

	// close extension tabs
	var enumerator = Services.wm.getEnumerator("navigator:browser");
	app_name = app_name.toLowerCase();

	while (enumerator.hasMoreElements()) {
		let
			gBrowser = enumerator.getNext().gBrowser,
			tabs = gBrowser.tabs,
			i = tabs.length;

		while (i--) {
			let URI = tabs[i].linkedBrowser.currentURI;

			if (URI.scheme === "chrome" && URI.host === app_name) {
				gBrowser.removeTab(tabs[i]);
			}
		}
	}
}

function install() {
	// https://bugzil.la/719376
	Services.strings.flushBundles();
}

function uninstall() {}
