"use strict";

var app, cfg, Tabs, Port;

app = {
	"name": /*~APP_NAME~*/"Viewhance",
	"version": /*~APP_VERSION~*/"0.9.6"
};


var Cc = Components.classes, Ci = Components.interfaces;
Components.utils["import"]("resource://gre/modules/Services.jsm");

app.baseURI = "chrome://" + app.name.toLowerCase()  + "/content/";

cfg = {
	PB: Services.prefs.getBranch("extensions." + app.name + "."),
	str: Cc["@mozilla.org/supports-string;1"].createInstance(Ci.nsISupportsString),
	getItem: function(k, fn) {
		try {
			fn(this.PB.getComplexValue(k, Ci.nsISupportsString).data);
		} catch (ex) {
			fn(null);
		}
	},
	setItem: function(k, v) {
		this.str.data = v;
		this.PB.setComplexValue(k, Ci.nsISupportsString, this.str);
	}
};

Tabs = {
	rgxNoLocal: /^[^:]{2,20}:/,
	curWin: function() {
		return Services.wm.getMostRecentWindow("navigator:browser");
	},
	getSelected: function(cb) {
		var win = this.curWin();
		cb(win && win.gBrowser ? win.gBrowser.selectedTab : {});
	},
	create: function(p) {
		var win = this.curWin();

		if (win) {
			if (!this.rgxNoLocal.test(p["url"])) {
				p["url"] = app.baseURI + p["url"];
			}

			win.gBrowser.loadOneTab(p["url"], {inBackground: !p["active"]});
		}
	}
};

Port = {
	parse_msg: function(msg) {
		var listener_id = msg.data.listener_id;
		var messager = msg.target.messageManager;

		return {
			msg: msg.data.data,
			origin: msg.data.origin,
			postMessage: function(message) {
				messager.sendAsyncMessage(listener_id, JSON.stringify(message));
			}
		};
	},
	listen: function(fn) {
		var gmm = Cc["@mozilla.org/globalmessagemanager;1"].getService(Ci.nsIMessageListenerManager);

		if (typeof fn === "function") {
			gmm.addMessageListener(app.name.toLowerCase() + ":background", fn);
			this.postMessage = fn;
		}
		else {
			gmm.removeMessageListener(app.name.toLowerCase() + ":background", this.postMessage);
			this.postMessage = null;
		}
	}
};
